
#include <iostream>  /* std::cout */
#include "account.h"

int main(int argc, const char *argv[])
{
    Account                a0(0, 1000);
    CurrentAccount         a1(1, 2000);
    SavingAccount          a2(2, 10000, 5);
    BlockedSavingAccount   a3(3, 50000);
    UnblockedSavingAccount a4(4, 100000);

    a0.debit(5000);     /* 5000€ debited (account)           */
    a1.debit(2500);     /* 2000€ debited (current account)   */
    a2.debit(1000);     /* 1000€ debited (saving account)    */
    a3.debit(20000);    /* 0€ debited    (blocked account)   */
    a4.debit(100001);   /* 0€ debited    (unblocked account) */

    std::cout << "All accounts:" << std::endl;
    std::cout << a0 << a1 << a2 << a3 << a4 << std::endl;
    
    std::cout << "Trying to debit and credit money:" << std::endl;
    Account* accounts[5] = {&a0, &a1, &a2, &a3, &a4};
    for (int i = 0; i < 5; i++) { 
        std::cout << "  debiting and crediting account number " << (*accounts[i])() << "..." << std::endl;
        accounts[i]->debit(999999);    /* will call Account::debit()  */
        accounts[i]->credit(999999+1); /* will call Account::credit() */
    }
    std::cout << std::endl;
    
    std::cout << "All accounts:" << std::endl;
    std::cout << a0 << a1 << a2 << a3 << a4 << std::endl;

    return EXIT_SUCCESS;
}
