
#ifndef CLIENT_H
#define CLIENT_H

#include <string>  /* std::string */
#include "account.h"

class Client {
    friend std::ostream& operator<<(std::ostream& os, const Client& client);
    private:
        std::string m_name;
        unsigned int m_identifier;
        CurrentAccount* m_current_account;
        UnblockedSavingAccount* m_saving_account;
    public:
        Client(std::string name, unsigned int identifier,
               CurrentAccount         *a0 = nullptr,
               UnblockedSavingAccount *a1 = nullptr);
        unsigned int identifier() const;
        void credit_current_account(double amount);
        void credit_saving_account(double amount);
        double debit_current_account(double amount);
        double debit_saving_account(double amount);
};

#endif /* end of include guard: CLIENT_H */
