
#include <iostream>  /* std::cout */
#include "client.h"

int main(int argc, const char *argv[])
{
    CurrentAccount         ca0(0, 2000), ca1(1, 5000);
    UnblockedSavingAccount sa0(2, 20000), sa1(3, 12000);
    
    Client c0("John",  1234);
    Client c1("Betty", 1235, &ca0);
    Client c2("Mike",  1236, nullptr, &sa0);
    Client c3("Jane",  1237, &ca1, &sa1);

    c1.credit_current_account(5000);
    c2.credit_saving_account(20000);
    c3.credit_current_account(10000);
    c3.credit_saving_account(50000);
    
    c1.debit_current_account(4000);
    c2.debit_saving_account(1000);
    c3.debit_current_account(1000);
    c3.debit_saving_account(9000);

    std::cout << c0 << std::endl;
    std::cout << c1 << std::endl;
    std::cout << c2 << std::endl;
    std::cout << c3 << std::endl;

    return EXIT_SUCCESS;
}
