
#ifndef ACCOUNT_H
#define ACCOUNT_H

#include <iostream>

#define IRATEBLOCKED   4
#define IRATEUNBLOCKED 2

class Account {
    private:
        unsigned int m_number;
    protected:
        double m_balance;
    public:
        Account(unsigned int number, double balance);
        void credit(double amount);
        double debit(double amount);
        void print(std::ostream& os) const;
        unsigned int operator()() const;
};


/* current account */
class CurrentAccount : public Account {
    public:
        CurrentAccount(unsigned int number, double balance);
        double debit(double amount);
        void print(std::ostream& os) const;
};


/* saving accounts */
class SavingAccount: public Account {
    private:
        double m_interest_rate;
    public:
        SavingAccount(unsigned int number, double balance, double interest_rate);
        void print(std::ostream& os) const;
        double add_interests();
};

class BlockedSavingAccount: public SavingAccount {
    public:
        BlockedSavingAccount(unsigned int number, double balance);
        double debit(double amount);
};

class UnblockedSavingAccount: public SavingAccount {
    public:
        UnblockedSavingAccount(unsigned int number, double balance);
        double debit(double amount);
};

std::ostream& operator<<(std::ostream& os, const Account&        account);
std::ostream& operator<<(std::ostream& os, const CurrentAccount& account);
std::ostream& operator<<(std::ostream& os, const SavingAccount&  account);

#endif /* end of include guard: ACCOUNT_H */
